package ir.ac.ut.ece.naeem;
/*
 * Created on Mar 1, 2004
 */

/**
 * This is some kind of list that its elements aren't have any order
 * The elements simply inserted at the end of it
 * @author Naeem
 * @see List
 * @version 1.0
 * @since insert, min, max, search, delete
 * 
 */
public class FIFOList extends List {

	/**
	 * @see List#insert(Comparable)
	 */
	public void insert(Comparable key) {
		if( head == null) {
			head = new Item( key, null);
			return;
		}
		
		Item index = head;
		Item previous = null;
		
		while( index != null) {
			previous = index;
			index = index.item;
		}
		
		previous.item = new Item( key, null);
	}

	/**
	 * @see List#min()
	 */
	public Item min() {
		Item min = head;
		Item index = head.item;
		
		while( index != null) {
			if( index.key.compareTo( min.key) < 0)
				min = index;
				
			index = index.item;
		}

		return min;
	}

	/**
	 * @see List#max()
	 */
	public Item max() {
		Item max = head;
		Item index = head.item;
		
		while( index != null) {
			if( index.key.compareTo( max.key) > 0)
				max = index;
				
			index = index.item;
		}

		return max;
	}

	/**
	 * @see List#find(Comparable)
	 */
	protected DItem find(Comparable key) {
		if( head == null)
			return new DItem( null, null);
		
		Item previous = null;
		Item index = head;
		
		while( index != null && !index.key.equals( key)) {
			previous = index;
			index = index.item;
		}
		
		return new DItem( index, previous);
	}

	public static void main(String[] args) {
		FIFOList mylist = new FIFOList();
		
		mylist.insert( new Integer( 12));
		mylist.insert( new Integer( 13));
		mylist.insert( new Integer( 21));
		mylist.insert( new Integer( 7));
		mylist.insert( new Integer( 19));
		mylist.insert( new Integer( 12));
		
		System.out.println( mylist.head);
		System.out.println( mylist.min());
		System.out.println( mylist.max());
		System.out.println( mylist.search( new Integer( 13)));
		System.out.println( mylist.search( new Integer( 3)));

	}
}
